#!/usr/bin/perl -w
# takes a table file and creates a graphic sizes x heights
# NEEDS: model1.agr, model2.agr and model3.agr files

print "Please, be sure that in your table each line has well specified before '.fsa':\n";
print "i.e. any string of the type [A-P][0-2][0-9].fsa\n";
print "e.g. projectPRJ_Plate057_wellP24.fsa is allowed\n\n";

# open table file (output of GeneMapper)
print "Table file name: ";
my $table = <STDIN>;
chop $table;
open(TABLE,$table) or die("Can't open table file $table\n");

# skip first line of input from the table file
my $line = <TABLE>;

my $color; # current color (0=O, 1=B, 2=G, 3=Y, 4=R)
my $prevColor = 0; # when previous color was orange nothing has to be done, standard is not considered

my $well;
my $prevWell = "";

# list of elements (as it is read from table file and sorted afterwards)
my $maxBlue = 0;
my @blueSizes = ();
my @blueHeight = ();
my $blueIndex = 0;

my $maxGreen = 0;
my @greenSizes = ();
my @greenHeight = ();
my $greenIndex = 0;

my $maxYellow = 0;
my @yellowSizes = ();
my @yellowHeight = ();
my $yellowIndex = 0;

my $maxRed = 0;
my @redSizes = ();
my @redHeight = ();
my $redIndex = 0;

my $tickSize; # tick size in y axe

while ($line = <TABLE>) {
  if ($line =~ /^"?O,/) {$color=0;}
  if ($line =~ /^"?B,/) {$color=1;}
  if ($line =~ /^"?G,/) {$color=2;}
  if ($line =~ /^"?Y,/) {$color=3;}
  if ($line =~ /^"?R,/) {$color=4;}

  if ($line =~ /([A-P][0-1]\d|[A-P]2[0-4])\.(fsa|FSA)/) {
    $well = $1;
    if ($well ne $prevWell) {
      `mkdir $well`;
      print "$well\n";
    }
  }

  if ($prevColor!=$color) { # changing color

    # create file per color (not orange)
    if ($prevColor == 1) { # we have BLUE color already analized
      if ($#blueSizes > 0) {
	open(BLUE,">blue2.agr") or die("Can't open table file blue2.agr\n");
	$max = $maxBlue*1.1;
	if ($max < 200) {$tickSize = 25;}
	else {
	  if ($max < 500) {$tickSize = 100;}
	  else {
	    if ($max < 1000) {$tickSize = 200;}
	    else {
	      if ($max < 5000) {$tickSize = 1000;}
	      else {
		if ($max >= 5000) {$tickSize = 2000;}
	      }}}}
	`echo \"@    world ymax $max\" >temp`;
	`echo \"@    yaxis  tick major $tickSize\" >temp2`;
	for ($i=0; $i<=$#blueSizes; $i++) {
	  print(BLUE "$blueSizes[$i] $blueHeight[$i]\n");
	}
	close BLUE;
	`cat model1.agr temp model2.agr temp2 model3.agr blue2.agr >blue.agr`;
	`mv blue.agr $well`;
      }

      # reset values for next blue cycle
      @blueSizes = ();
      @blueHeight = ();
      $blueIndex = 0;
      $maxBlue = 0;
    }

    if ($prevColor == 2) { # we have GREEN color already analized
      if ($#greenSizes > 0) {
	open(GREEN,">green2.agr") or die("Can't open table file green2.agr\n");
	$max = $maxGreen*1.1;
	if ($max < 200) {$tickSize = 25;}
	else {
	  if ($max < 500) {$tickSize = 100;}
	  else {
	    if ($max < 1000) {$tickSize = 200;}
	    else {
	      if ($max < 5000) {$tickSize = 1000;}
	      else {
		if ($max >= 5000) {$tickSize = 2000;}
	      }}}}
	`echo \"@    world ymax $max\" >temp`;
	`echo \"@    yaxis  tick major $tickSize\" >temp2`;
	for ($i=0; $i<=$#greenSizes; $i++) {
	  print(GREEN "$greenSizes[$i] $greenHeight[$i]\n");
	}
	close GREEN;
	`cat model1.agr temp model2.agr temp2 model3.agr green2.agr >green.agr`;
	`mv green.agr $well`;
      }

      # reset values for next green cycle
      @greenSizes = ();
      @greenHeight = ();
      $greenIndex = 0;
      $maxGreen = 0;
    }

    if ($prevColor == 3) { # we have YELLOW color already analized
      if ($#yellowSizes > 0) {
	open(YELLOW,">yellow2.agr") or die("Can't open table file yellow2.agr\n");
	$max = $maxYellow*1.1;
	if ($max < 200) {$tickSize = 25;}
	else {
	  if ($max < 500) {$tickSize = 100;}
	  else {
	    if ($max < 1000) {$tickSize = 200;}
	    else {
	      if ($max < 5000) {$tickSize = 1000;}
	      else {
		if ($max >= 5000) {$tickSize = 2000;}
	      }}}}
	`echo \"@    world ymax $max\" >temp`;
	`echo \"@    yaxis  tick major $tickSize\" >temp2`;
	for ($i=0; $i<=$#yellowSizes; $i++) {
	  print(YELLOW "$yellowSizes[$i] $yellowHeight[$i]\n");
	}
	close YELLOW;
	`cat model1.agr temp model2.agr temp2 model3.agr yellow2.agr >yellow.agr`;
	`mv yellow.agr $well`;
      }

      # reset values for next yellow cycle
      @yellowSizes = ();
      @yellowHeight = ();
      $yellowIndex = 0;
      $maxYellow = 0;
    }

    if ($prevColor == 4) { # we have RED color already analized
      if ($#redSizes > 0) {
	open(RED,">red2.agr") or die("Can't open table file red2.agr\n");
	$max = $maxRed*1.1;
	if ($max < 200) {$tickSize = 25;}
	else {
	  if ($max < 500) {$tickSize = 100;}
	  else {
	    if ($max < 1000) {$tickSize = 200;}
	    else {
	      if ($max < 5000) {$tickSize = 1000;}
	      else {
		if ($max >= 5000) {$tickSize = 2000;}
	      }}}}
	`echo \"@    world ymax $max\" >temp`;
	`echo \"@    yaxis  tick major $tickSize\" >temp2`;
	for ($i=0; $i<=$#redSizes; $i++) {
	  print(RED "$redSizes[$i] $redHeight[$i]\n");
	}
	close RED;
	`cat model1.agr temp model2.agr temp2 model3.agr red2.agr >red.agr`;
	`mv red.agr $prevWell`; # red is plotted when we already are in the new well
      }

      # reset values for next red cycle
      @redSizes = ();
      @redHeight = ();
      $redIndex = 0;
      $maxRed = 0;
    }

  }

  # insert data in data structures and temporary files
  if ($color == 1) { # blue color
    if ($line =~ /^"?B,\d{1,4}"?\s+.*\.(FSA|fsa)\s+(\d+\.?\d*)\t(\d+)\t(\d+)\t(\d+)/) {
      if (($2>=50) && ($2<=500)) {
	if ($3 > $maxBlue) {$maxBlue = $3;}
	$blueSizes[$blueIndex] = $2;
	$blueHeight[$blueIndex] = $3;
	$blueIndex++;
      }
    }
  }

  if ($color == 2) { # green color
    if ($line =~ /^"?G,\d{1,4}"?\s+.*\.(FSA|fsa)\s+(\d+\.?\d*)\t(\d+)\t(\d+)\t(\d+)/) {
      if (($2>=50) && ($2<=500)) {
	if ($3 > $maxGreen) {$maxGreen = $3;}
	$greenSizes[$greenIndex] = $2;
	$greenHeight[$greenIndex] = $3;
	$greenIndex++;
      }
    }
  }

  if ($color == 3) { # yellow color
    if ($line =~ /^"?Y,\d{1,4}"?\s+.*\.(FSA|fsa)\s+(\d+\.?\d*)\t(\d+)\t(\d+)\t(\d+)/) {
      if (($2>=50) && ($2<=500)) {
	if ($3 > $maxYellow) {$maxYellow = $3;}
	$yellowSizes[$yellowIndex] = $2;
	$yellowHeight[$yellowIndex] = $3;
	$yellowIndex++;
      }
    }
  }

  if ($color == 4) { # red color
    if ($line =~ /^"?R,\d{1,4}"?\s+.*\.(FSA|fsa)\s+(\d+\.?\d*)\t(\d+)\t(\d+)\t(\d+)/) {
      if (($2>=50) && ($2<=500)) {
       	if ($3 > $maxRed) {$maxRed = $3;}
	$redSizes[$redIndex] = $2;
	$redHeight[$redIndex] = $3;
	$redIndex++;
      }
    }
  }

  $prevColor = $color;
  $prevWell = $well;
}

if ($color == 4) { # if last color picked is red then work on it
  if ($#redSizes > 0) {
    open(RED,">red2.agr") or die("Can't open table file red2.agr\n");
    $max = $maxRed*1.1;
    if ($max < 500) {$tickSize = 100;}
    else {
      if ($max < 1000) {$tickSize = 200;}
      else {
        if ($max < 5000) {$tickSize = 1000;}
        else {
	if ($max >= 5000) {$tickSize = 2000;}
      }}}
    `echo \"@    world ymax $max\" >temp`;
    `echo \"@    yaxis  tick major $tickSize\" >temp2`;
    for ($i=0; $i<=$#redSizes; $i++) {
      print(RED "$redSizes[$i] $redHeight[$i]\n");
    }
    close RED;
    `cat model1.agr temp model2.agr temp2 model3.agr red2.agr >red.agr`;
    `mv red.agr $prevWell`;
  }
}

`rm blue2.agr`;
`rm green2.agr`;
`rm yellow2.agr`;
`rm red2.agr`;
`rm temp`;
`rm temp2`;
